proc ingestVolInitX {} {
    global gvar ICV

    #Set the header
    set formatLine "%-3s %-13s %-10s %-4s %-10s"
    set formatHeader "Id Unit SEG Queue Media" 
    set gvar(ingestVolHeader) [eval format [concat \"$formatLine\" $formatHeader]]
    
    #save my cv
    set ICV .astoIngestVol.top.wdg.can
    statusIngestVol
}


proc statusIngestVol {} {
    global gvar ICV
 
    set queueBuffer ""
    set gvar(ingestVolStatus) "Getting info from DB..."
    update idletasks

#    set query "
#    	select m.media_request_id, m.media_request_name, 
#	    media_request_type, u.media_unit_name, m.media_type 
#        from $gvar(database)..$gvar(units_table) u, 
#	    $gvar(database)..$gvar(media_table) m
#    	where u.status = 'C' 
#    	    and m.media_request_id = u.media_request_id
#	    and u.media_unit_name in 
#		(select distinct diskname from $gvar(database)..$gvar(CD,file)
#		 union select distinct diskname from $gvar(database)..$gvar(VD,file)
#		 union select distinct tapename from $gvar(database)..$gvar(TP,file))
#    	order by m.media_request_id"
    set query "
    	select m.media_request_id, m.media_request_name, 
	    media_request_type, u.media_unit_name, m.media_type 
        from $gvar(database)..$gvar(units_table) u, 
	    $gvar(database)..$gvar(media_table) m
    	where u.status = 'C' 
    	    and m.media_request_id = u.media_request_id
	    and u.media_unit_name in  --
		(select distinct volume from $gvar(database)..mfs)
    	order by m.media_request_id"

    Debug "query: $query" 1
    set archiveVolumes [Sybsql $query]
    Debug "Result: $archiveVolumes" 2
    set query "
        select m.media_request_id, m.media_request_name, 
	    media_request_type, u.media_unit_name, m.media_type 
        from $gvar(database)..$gvar(units_table) u, 
	    $gvar(database)..$gvar(media_table) m
    	where u.status = 'C' 
     	    and m.media_request_id = u.media_request_id
            and m.media_request_type = 'USER'
        order by m.media_request_id"
    Debug "query: $query" 1
    set userVolumes [Sybsql $query]
    Debug "Result: $userVolumes" 2
    
    if {$userVolumes != ""} {
	set results [concat $archiveVolumes $userVolumes]
    } else {
	set results $archiveVolumes
    }

    #Update the list box, formatting the results as needed.
    $ICV.astoIngestVolWdg deleteItem 0 end
    if { $results == "error" || $results == ""} { 
	set gvar(ingestVolStatus) ""
	return 
    }
    set formatLine "%-3s %-13s %-10s %-4s %-10s"
    foreach lines $results {
        set id            [lindex $lines 0]
	set segregation   [lindex $lines 1]
	set requestType   [lindex $lines 2]
	set unitName      [lindex $lines 3]
	set mediaType	  [lindex $lines 4]
	
	set formatHeader "$id $unitName $segregation $requestType $mediaType "
	set line [eval format [concat \"$formatLine\" $formatHeader]]
	lappend queueBuffer $line 
	lappend gvar(ingestVolList) $formatHeader 
	$ICV.astoIngestVolWdg addItem end $line 
    }
    set gvar(ingestVolStatus) ""
}


proc ingestVol {} {
    global gvar ICV

    set list [$ICV.astoIngestVolWdg getSelection]
    if {$list== ""} {
	 Info "You have to select a volume first." 
	 return }
    
    $ICV.ingestVolButtonWdg disable
    foreach media_entry $list {
	set id [lindex $media_entry 0]
	set mediaName [lindex $media_entry 1]
	set volType [string tolower [lindex $media_entry 4]]
	set gvar(ingestVolStatus) "Ingesting $id / $mediaName"
	update idletasks
	Log "Finalize volume $mediaName" Info
	#set retCode [ingestVolexCom "astoIngest -i $id -n $mediaName -vol cd -v"]

	if {![cleanVolume $id $mediaName]} {
	    set query "update $gvar(units_table) 
                       set status = 'D'
                       where media_unit_name = '$mediaName'"
	    Debug "query: $query" 1
	    set results [Sybsql $query]
	    Debug "Result: $results" 2
	}	
    }
    set gvar(ingestVolStatus) "Selected media ingested"
    update idletasks
    statusIngestVol
    after 1  checkVolumes
    $ICV.ingestVolButtonWdg enable
}


proc cleanVolume {id mediaName} {
    global gvar

    #set query "select status from $gvar(units_table) where
#media_unit_name = '$mediaName'"
    #Debug "query: $query" 1
    #set status [Sybsql $query]
    #Debug "Result: $status" 2

    #if {$status == "C"} {
    #    return 0
    #}

    
    set query "update $gvar(units_table) 
                       set status = 'W'
                       where media_unit_name = '$mediaName'"
    
    Debug "query: $query" 1
    set results [Sybsql $query]
    Debug "Result: $results" 2
    
    set cmd "mediaCleanup -v -i $id -n $mediaName"
    
    catch {eval blt::bgexec gvar(cleanupStatus) -output gvar(cleanupOutput) \
	       -error gvar(cleanupErrors) [lindex $cmd 0] [lrange $cmd 1 end]} msg
    
    if {[string match "*Error*" $gvar(cleanupOutput)]} {
	Log "Error invoking command:\n\"$cmd\"" Error
	Info "Error invoking command:\n\"$cmd\"" 
	Debug "mediaCleanup Error: $gvar(cleanupErrors) --- msg: $msg" 1 
	return 1
    }
    
    return 0
}


proc ingestVolexCom {cmd} {
    global ingestVolStatus ingestVolOutput ingestVolErrors

    set ingestVolStatus 0
    Debug "Ex: $cmd" 1
    if {[catch {eval blt::bgexec ingestVolStatus -output ingestVolOutput  -error ingestVolErrors [lindex $cmd 0] [lrange $cmd 1 end]} msg]} {
        Info "Error invoking command:\n \"$cmd\"" 
	Debug "Exec Error: $ingestVolErrors --- msg: $msg " 1
	Debug "Result command: $ingestVolOutput - cmd : $cmd" 1
	return -1
    }
    
    # vwait
    # tkwait variable execStatus
    set ingestVolStatus 0
    #puts "Result command: $ingestVolOutput - cmd : $cmd"
    return $ingestVolOutput
}
 

