#!/bin/bash 
#
# msql2d: starts/stops msql2d server
#
# chkconfig: 2345 97 03
#
# description: Starts and stops the msql2d daemon
#
# processname: msql2d
#
# config: /opt/msql2
# pidfile: /MSQL2/msql2d.pid

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 

export PATH=/opt/msql2/bin:$PATH

RETVAL=0

start() {
        echo -n $"Starting msql2d: "
	daemon --user $OWNER start-msql2d
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/msql2d
        return $RETVAL
}

stop() {
        echo -n $"Shutting down msql2d: "
        killproc msql2d
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/msql2d
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status msql2d
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
