/**
 * @author N. Kornweibel
 * @version 1.0
 * A simple interface to encalsulate the generation of observation descriptions
 * in the DataModel.
 */
package org.eso.gasgano.datamodel;

import org.eso.gasgano.datamodel.gui.FitsFileOBComponent;
import org.eso.gasgano.datamodel.gui.OBComponent;
import org.eso.gasgano.keyword.Keyword;

public class BasicObservationDescription implements ObservationDescription {

    public BasicObservationDescription() {
        Keyword k[] = new Keyword[1];
        k[0] = new Keyword(Keyword.OBS_NAME, null);
        FitsFileOBComponent.addToDefaultKeywordQuery(k);
    }
 
    /**
     * @param o The Observation to have its description set.
     * @param obc The OBComponent used to config Observation o.
     */
    public void setDescription(Observation o,
            OBComponent obc) {
        if (obc instanceof FitsFileOBComponent) {
            FitsFileOBComponent ffob = (FitsFileOBComponent)obc;
            Keyword[] k = FitsFileOBComponent.getDefaultKeywordQuery();
            String obsName = new String("");
            String obsId = o.getId();
            for (int i = 0; i < k.length; i++) {
                if (k[i].getName().equals(Keyword.OBS_NAME)) {
                    if (k[i].getValue() != null) {
                        obsName = k[i].getValue();
                    }
                    break;
                }
            }
            // format our description.
            o.setDescription(new String(obsId+"    "+obsName));
        }
    }
}
// end of file BasicObservationDescription.java.
