/**
 * @author N. Kornweibel
 * @version 1.0
 * A very simple program description showing the Program-ID,
 * Instrument and PI.
 */

package org.eso.gasgano.datamodel;

import org.eso.gasgano.datamodel.filesystem.DFSDataModel;
import org.eso.gasgano.datamodel.gui.FitsFileOBComponent;
import org.eso.gasgano.datamodel.gui.OBComponent;
import org.eso.gasgano.keyword.Keyword;

public class BasicProgramDescription implements ProgramDescription {

     public BasicProgramDescription() {
         Keyword k[] = new Keyword[2];
         k[0] = new Keyword(Keyword.INSTRUMENT, null);
         k[1] = new Keyword(Keyword.PI, null);
         FitsFileOBComponent.addToDefaultKeywordQuery(k);
     }

    /**
     * @param p The program to have its description set.
     * @param obc The OBComponent used to build the description.
     */
     public void setDescription(Program p, OBComponent obc) {
         if (obc instanceof FitsFileOBComponent) {
             FitsFileOBComponent ffob = (FitsFileOBComponent)obc;
             Keyword[] k = FitsFileOBComponent.getDefaultKeywordQuery();
             String instrument = new String("");
             String pi = new String("");
             String progid = p.getId();
             for (int i = 0; i < k.length; i++) {
                 if (k[i].getName().equals(Keyword.INSTRUMENT)) {
                     if (k[i].getValue() != null) {
                         instrument = k[i].getValue();
                     }
                 } else if (k[i].getName().equals(Keyword.PI)) {
                     if (k[i].getValue() != null) {
                         pi = k[i].getValue();
                     }
                 }
             }
             // format our description.
	     if ( progid.equals(DFSDataModel.UNKNOWN_PROGRAM_ID)) { 
	       p.setDescription(new String(progid ) );
	     } else { 
	       p.setDescription(new String(progid+"    "+instrument+"    "+pi));
	     }
         }
     }
}
// end of file BasicProgramDescription.java.
