package org.eso.gasgano.tools;

import java.io.File;

/**
 * @author nkornwei
 *
 * Directory and file path utilities.
 */
public class DirUtils {

    /**
     * method used for a common policy on all filesystem related
     * preferences: if they start with "/" they are interpreted as 
     * absolute, if they start with "./" they are interpreted as local
     * and if none of the above applies, they are interpeted as
     * relative to the user's home directory
     **/

    public static String convertAbsoluteDir(String dir) {
        if (dir == null) {
            return new String("");
        }
        if (dir.startsWith(File.separator)) { // it's absolute, return it
            return dir;
        }
        if (dir.startsWith("./")) { // it's intentionally local
            return dir;
        }
        String tmpString =
            new String(
                System.getProperties().getProperty("user.home")
                    + File.separator
                    + dir);
        return tmpString;
    }

}
