package org.eso.gasgano.tools;

import java.text.DecimalFormat;

/**
 * @author nkornwei
 *
 * RA Conversion routine.
 */
public class RADECConverter {

    private static double secCon;
    private static double DEG = 0.0;
    private static int signCon = 1;
    private static int hourCon, degCon, minCon = 0;

    // RA and DEC convertion variables 
    private static DecimalFormat formD = new DecimalFormat("00.##");
    private static DecimalFormat formI = new DecimalFormat("00");

    /**
     * a bit of computation to convert RA in degrees and seconds
     */

    public static String RAconvert(String d) {
        String sign = new String("");
        try {
            DEG = (Double.valueOf(d)).doubleValue();
        } catch (NumberFormatException nfe) {
            System.out.println(nfe);
            return d;
        }

        if (DEG < 0.) {
            signCon = -1;
            sign = new String("-");
        } else {
            signCon = 1;
            sign = new String("");
        }

        DEG *= signCon;

        hourCon = (int) (DEG / 15.0);
        minCon = Math.abs((int) ((DEG / 15.0 - hourCon) * 60.0));
        secCon = Math.abs(((DEG / 15.0 - hourCon) * 3600.0 - minCon * 60.0));

        try {
            return new String(
                sign
                    + formI.format(hourCon)
                    + ":"
                    + formI.format(minCon)
                    + ":"
                    + formD.format(secCon));
        } catch (IllegalArgumentException iae) {
            return new String(
                sign
                    + String.valueOf(hourCon)
                    + ":"
                    + String.valueOf(minCon)
                    + ":"
                    + String.valueOf(secCon));
        }
    }

    /**
     * a bit of computation to convert DEC  in degrees and seconds
     */

    public static String DECconvert(String d) {
        String sign = null;
        try {
            DEG = (Double.valueOf(d)).doubleValue();
        } catch (NumberFormatException nfe) {
            System.out.println(nfe);
            return d;
        }

        if (DEG < 0.) {
            signCon = -1;
            sign = new String("-");
        } else {
            signCon = 1;
            sign = new String("");
        }

        DEG *= signCon;

        degCon = (int) DEG;
        minCon = Math.abs((int) ((DEG - degCon) * 60.0));
        secCon = Math.abs(((DEG - degCon) * 3600.0 - minCon * 60.0));

        try {
            return new String(
                sign
                    + formI.format(degCon)
                    + ":"
                    + formI.format(minCon)
                    + ":"
                    + formD.format(secCon));
        } catch (IllegalArgumentException iae) {
            return new String(
                sign
                    + String.valueOf(degCon)
                    + ":"
                    + String.valueOf(minCon)
                    + ":"
                    + String.valueOf(secCon));
        }
    }
}
