package org.eso.ohs.core.dbb.client;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.eso.ohs.core.utilities.Convert;

/**
 * $Id: DbbHHMMDateTime.java,v 1.1 2005/04/11 13:53:44 tcanavan Exp $
 * @author amchavan, 09-Oct-2001: creation from Coordinate.java 
 */

public class DbbHHMMDateTime implements DbbDataType  {
       
    
    private SimpleDateFormat simpleFormat_ = new SimpleDateFormat(Convert.ST_TIME_FORMAT);

    
    /** 
     * @return An an string equivaleny in HH:SS format
     *
     * @see Convert#longToISODate( long )
     */

    public String fromDatabaseData( Object obj ) {
        long seconds = ((Integer)obj).longValue();
        simpleFormat_ = new SimpleDateFormat(Convert.ST_TIME_FORMAT);
        Date dt = new Date(seconds * Convert.MILLISECS_PER_SEC);
        String fmt = simpleFormat_.format(dt);
        return fmt;
    }
    
    
    /**
     * @return An integer equivalent to the ISO date+time input string.
     *
     * @see Convert#ISOdateToLong( String )		
     */
    public Object toDatabaseData( String value ) {
	   long ret;
       ret = Convert.convertHHMMTOSeconds(value);
	   return new Long( ret );
    }


    /** @return The display data type */
    public Class getDataType() {
	return String.class;
    }


    /** @return The database data type */
    public Class getDatabaseType() {
	return Integer.class;
    }


    /** @return the display data type length */
    public int getDataTypeLength() {
	   return simpleFormat_.toPattern().length();
    }
}
