package org.eso.ohs.core.dbb.htmlclient;

import org.eso.ohs.core.dbb.sql.DbbSqlChunk;

/**
 * This is an implementation of the DbbHtmlWidget abstract class,
 * defining a text field.
 * <br>
 * @author amchavan, ESO 09-Dec-2003
 * @version $Revision: 1.4 $
 */

// $Id: DbbHtmlTextField.java,v 1.4 2004/04/13 14:46:00 ddorigo Exp $

public class DbbHtmlTextField extends DbbHtmlWidget {

	/** Deafult width for text widgets */
	public final static int COLUMNSIZE = 15;

	public static final String cvsID_ =
		"$Id: DbbHtmlTextField.java,v 1.4 2004/04/13 14:46:00 ddorigo Exp $";

	/**
	 * Create an instance associated with a specific chunk.
	 *
	 * @param chunk DbbSqlChunk object.
	 */
	public DbbHtmlTextField(DbbSqlChunk chunk) {
		this(chunk.getLabel(), chunk);
	}

	/**
	 * Create an instance, with a specific label, associated with a
	 * specific chunk
	 *
	 * @param labeltext Label text to be displayed.
	 * @param chunk     DbbSqlChunk object.
	 */
	public DbbHtmlTextField(String labeltext, DbbSqlChunk chunk) {
		super(labeltext, chunk);
		setDefault("");
	}

	/** Implementation of the abstract method */
	public String render(int indentLevel) {
		String name = getName();
		StringBuffer sb = new StringBuffer();

		sb
			.append(indentSpaces(indentLevel))
			.append("<td> ")
			.append(getLabel())
			.append(" </td>\n")
			.append(indentSpaces(indentLevel))
			.append("<td> ")
			.append("<input type=\"text\" name=\"")
			.append(name)
			.append("\">")
			.append(" </td>\n");

		return sb.toString();
	}

	/**
	 * Set the widget's value (implementation of the abstract method).
	 *
	 * @param val Can be any string.
	 */
	public void set(String val) {
		boolean active = false;
		if (val != null && val.length() > 0) {
			active = true;
		}
		DbbSqlChunk c = getSqlChunk();
		c.setActive(active);
		c.setValue(val);
		value_ = val;
	}
}
