package org.eso.ohs.core.utilities;

import java.util.Vector;

import org.apache.log4j.Logger;

/**
 * Trivial class to hold a (key, value) pair.
 * 
 * @author Bob Kemp
 * @deprecated Use java.util.LinkedHashMap instead. (amchavan, 08-Jun-2005)
 */

// $Id: AssocList.java,v 1.3 2005/06/08 08:23:02 amchavan Exp $ 

public class AssocList {

    private static Logger stdlog_ = Logger.getLogger(AssocList.class);

    private Vector elements_ = new Vector();

    public AssocList() {
    }

    public AssocList add(String newKey, Object newValue) {
        elements_.addElement(new Element(newKey, newValue));
        return this;
    }

    public String getKeyFromObjectAsString(String object) {
        for (int j = 0; j < elements_.size(); j++) {
            Element elem = (Element) elements_.elementAt(j);
            if (object.equals((String) elem.value))
                return (String) elem.key;
        }
        return null;
    }

    /**
     * Get the value from a vector give a particular index in the
     * Vector
     * @param index
     * @return String
     */

    public String getValueFromIndex(int index) {
        for (int j = 0; j < elements_.size(); j++) {
            if (j == index) {
                Element elem = (Element) elements_.elementAt(j);
                return (String) elem.value;
            }
        }
        return null;
    }

    public Object valueFor(String key) {
        int size = elements_.size();

        for (int j = 0; j < size; j++) {
            Element elem = (Element) elements_.elementAt(j);

            if (elem.key.equals(key)) {
                return elem.value;
            }
        }
        return null;
    }

    /**
     * This is an alias for the <code>valueFor()</code> method.
     * <BR>
     * Added to make the API to this class more similar to 
     * that of Hashtable.
     *
     * @see #valueFor( String )
     * <br>ChangeLog: amchavan, 13-Sep-2001: creation
     */
    public Object get(String key) {
        return valueFor(key);
    }

    /**
     * This is an alias for the <code>add()</code> method, with 
     * a different return value.
     * <BR>
     * Added to make the API to this class more similar to 
     * that of Hashtable.
     *
     * @return The value.
     * <br>ChangeLog: amchavan, 13-Sep-2001: creation
     */
    public Object put(String key, Object value) {
        add(key, value);
        return value;
    }

    /** 
     * @return The number of elements in this list.
     * <br>ChangeLog: A M Chavan, 03-08-2001: creation.
     */
    public int size() {
        return elements_.size();
    }

    public String[] keys() {
        String[] keys = new String[elements_.size()];
        for (int j = 0; j < keys.length; j++) {
            Element elem = (Element) elements_.elementAt(j);
            keys[j] = elem.key;
        }
        return keys;
    }

    public Object[] values() {
        Object[] values = new Object[elements_.size()];
        for (int j = 0; j < values.length; j++) {
            Element elem = (Element) elements_.elementAt(j);
            values[j] = elem.value;
        }
        return values;
    }

    public String[] valuesAsStrings() {
        String[] values = new String[elements_.size()];
        for (int j = 0; j < values.length; j++) {
            Element elem = (Element) elements_.elementAt(j);
            values[j] = elem.value.toString();
        }
        return values;
    }

    public void printKeys() {
        System.out.print("Keys: ");
        printList(keys());
    }

    public void printValues() {
        stdlog_.debug("Values: " + printList(values()) + "\n");
    }

    private String printList(Object[] list) {
        StringBuffer rc = new StringBuffer();
        rc.append("[");

        if (list.length > 0) {
            rc.append(list[0]);

            for (int j = 1; j < list.length; j++) {
                rc.append(", ");
                rc.append(list[j]);
            }
        }

        rc.append(" ]");
        return rc.toString();
    }

    public static class Element {

        public final String key;

        public final Object value;

        public Element(String theKey, Object theValue) {
            key = theKey;
            value = theValue;
        }

    }
}
