package org.eso.ohs.dfs;


/**
 * Record in the PanelObsRuns database.
 * 
 * <p>
 * $Id: PanelObsRun.java,v 1.12 2003/12/07 12:49:30 tcanavan Exp $
 */
public class PanelObsRun extends BusinessObject {

    public static final int DEF_INVALID_RANK = -1; 
    public static final int DEF_RANK = -1; 
    public static final int DEF_PERIOD = 67; 
    private String runId_ = "";
    private long programmeDbId_ = -1;
    private float grade_ = -1;
    private int rank_ = DEF_RANK;
    private int period_ = DEF_PERIOD;
    private float nights_;
    private float sigma_;
    private float avgGrade_;
    private float avgNights_;
    private String obsMode_;
    private String telescope_ = "";
    private String instrument_ = "";
    private String reqTime_ = "";
    private String month_;
    private String moon_;
    private String seeing_;
    private String skyTransparency_;
    private String title_;
    private String applicants_;
    private int maxRank_ = -1;
    private int minRank_ = -1;

    public PanelObsRun() {
    }

    /**
     * Set value for runId_ property
     *
     * @param new value of the property
     */
    public void setRunId(String newValue) {
	runId_ = newValue;
    }


    /**
     * Get value for runId_ property
     *
     * @return current value of the property
     */
    public String getRunId() {
	return runId_;
    }


    /**
     * Set value for programmeDbId_ property
     *
     * @param new value of the property
     */
    public void setProgrammeDbId(long newValue) {
	programmeDbId_ = newValue;
    }


    /**
     * Get value for programmeDbId_ property
     *
     * @return current value of the property
     */
    public long getProgrammeDbId() {
	return programmeDbId_;
    }


    /**
     * Get value for grade_ property
     *
     * @return the current value of the property
     */
    public void setGrade(float newValue) {
	grade_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for grade_ property
     *
     * @return the current value of the property
     */
    public float getGrade() {
	return grade_;
    }


    /**
     * Get value for maxRank_ property
     *
     * @return the current value of the property
     */
    public void setMaxRank(int newValue) {
	maxRank_ = newValue;
	//firePropertyChangeEvent();
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public int getMaxRank() {
	return maxRank_;
    }


    /**
     * Get value for minRank_ property
     *
     * @return the current value of the property
     */
    public void setMinRank(int newValue) {
	minRank_ = newValue;
	//firePropertyChangeEvent();
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public int getMinRank() {
	return minRank_;
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public void setRank(int newValue) {
	rank_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for rank_ property
     *
     * @return the current value of the property
     */
    public int getRank() {
	return rank_;
    }
    /**
     * Get value for period_ property
     *
     * @return the current value of the property
     */
    public void setPeriod(int newValue) {
	period_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for period_ property
     *
     * @return the current value of the property
     */
    public int getPeriod() {
	return period_;
    }


    /**
     * Get value for nights_ property
     *
     * @return the current value of the property
     */
    public void setNights(float newValue) {
	nights_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for nights_ property
     *
     * @return the current value of the property
     */
    public float getNights() {
	return nights_;
    }


    /**
     * Get value for sigma_ property
     *
     * @return the current value of the property
     */
    public void setSigma(float newValue) {
	sigma_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for sigma_ property
     *
     * @return the current value of the property
     */
    public float getSigma() {
	return sigma_;
    }


    /**
     * Get value for avgGrade_ property
     *
     * @return the current value of the property
     */
    public void setAvgGrade(float newValue) {
	avgGrade_ = newValue;
    }


    /**
     * Get value for avgGrade_ property
     *
     * @return the current value of the property
     */
    public float getAvgGrade() {
	return avgGrade_;
    }


    /**
     * Get value for avgNights_ property
     *
     * @return the current value of the property
     */
    public void setAvgNights(float newValue) {
	avgNights_ = newValue;
    }


    /**
     * Get value for avgNights_ property
     *
     * @return the current value of the property
     */
    public float getAvgNights() {
	return avgNights_;
    }


    /**
     * Get value for obsMode_ property
     *
     * @return the current value of the property
     */
    public void setObsMode(String newValue) {
	obsMode_ = newValue;
	firePropertyChangeEvent();
    }


    /**
     * Get value for obsMode_ property
     *
     * @return the current value of the property
     */
    public String getObsMode() {
	return obsMode_;
    }


    /**
     * Set new value for telescope_ property
     *
     * @param newValue the new value for the property
     */
    public void setTelescope(String newValue) {
	    telescope_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for telescope_ property
     *
     * @return the current value of the property
     */
    public String getTelescope() {
	    return telescope_;
    }

    /**
     * Set new value for instrument_ property
     *
     * @param newValue the new value for the property
     */
    public void setInstrument(String newValue) {
	    instrument_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for instrument_ property
     *
     * @return the current value of the property
     */
    public String getInstrument() {
	    return instrument_;
    }


    /**
     * Set new value for reqTime_ property
     *
     * @param newValue the new value for the property
     */
    public void setReqTime(String newValue) {
	    reqTime_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for reqTime_ property
     *
     * @return the current value of the property
     */
    public String getReqTime() {
	    return reqTime_;
    }



    /**
     * Set new value for month_ property
     *
     * @param newValue the new value for the property
     */
    public void setMonth(String newValue) {
	    month_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for month_ property
     *
     * @return the current value of the property
     */
    public String getMonth() {
	    return month_;
    }


    /**
     * Set new value for moon_ property
     *
     * @param newValue the new value for the property
     */
    public void setMoon(String newValue) {
	    moon_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for moon_ property
     *
     * @return the current value of the property
     */
    public String getMoon() {
	    return moon_;
    }


    /**
     * Set new value for seeing_ property
     *
     * @param newValue the new value for the property
     */
    public void setSeeing(String newValue) {
	    seeing_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for seeing_ property
     *
     * @return the current value of the property
     */
    public String getSeeing() {
	    return seeing_;
    }


    /**
     * Set new value for skyTransparency_ property
     *
     * @param newValue the new value for the property
     */
    public void setSkyTransparency(String newValue) {
	    skyTransparency_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for skyTransparency_ property
     *
     * @return the current value of the property
     */
    public String getSkyTransparency() {
	    return skyTransparency_;
    }


    /**
     * Set new value for title_ property
     *
     * @param newValue the new value for the property
     */
    public void setTitle(String newValue) {
	    title_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for title_ property
     *
     * @return the current value of the property
     */
    public String getTitle() {
	    return title_;
    }


    /**
     * Set new value for applicants_ property
     *
     * @param newValue the new value for the property
     */
    public void setApplicants(String newValue) {
	    applicants_ = newValue;
	    //firePropertyChangeEvent();
    }


    /**
     * Get value for applicants_ property
     *
     * @return the current value of the property
     */
    public String getApplicants() {
	    return applicants_;
    }



    public Object accept(BusinessVisitor v, Object arg) {
	return null;
    }
    /**
     * @see org.eso.ohs.dfs.StorableObject#postProecess()
     */
    public void postProecess() {
    }


}


