package org.eso.ohs.instruments;

import java.util.StringTokenizer;


/**
 * Instancaites a class that repesrents a list of numbers. 
 * The string that contains the list of numbers is checked for its validity.
 * <p>
 * $Id: NumListParameter.java,v 1.4 2001/07/25 12:15:12 tcanavan Exp $
 * @author Tim Canavan 
 */


public class NumListParameter extends NumberParameter {

    static final long serialVersionUID = 348313342399496295L;

    /**
     * Constructor for NumListParameter
     */


    public NumListParameter(ParamMetaData pMeta) {
        super(pMeta);
    }


    /**
     * Get ToolTip text for NumListParameter
     * @return tool tiptext
     */

    public String getToolTipText() {
        String tooltp = "Enter Valid Parameter";
        boolean range = false;
        if(getMinValue() != null
	&& getMaxValue() != null)
            range = true;
        Float[] validValues = getValidValues();
        StringBuffer validFloats = new StringBuffer(20);
        if(validValues != null) {
	    for(int i=0;i<validValues.length;i++) 
                validFloats.append(validValues[i].floatValue() + " ");            
        }
        StringBuffer rangeBuffer = null;
        if(range) {
             rangeBuffer = new StringBuffer();
             rangeBuffer.append(getMinValue());        
             rangeBuffer.append("..");
             rangeBuffer.append(getMaxValue());
	}
        if(range==true && validValues == null)
            tooltp = "List of Floats within range " + rangeBuffer.toString();
        if(!range && validValues != null)
            tooltp = "List of Floats from the  list " + validFloats.toString();
        if(range==true && validValues != null)    
            tooltp = "List of floats within range  " + rangeBuffer.toString() + " or in list "
                                        + validFloats.toString();       
        if(!range && validValues == null)
            tooltp = "Enter list of Floating points";
        return tooltp;
    }

    public char getDBTypeCode() {
        return 'L';
    }


    /**
     * This method verifies a string is a list of numbers
     * @param value String repesenting a list of numbers
     * @return status The status of the value entered.
     */

    public boolean verifyValue(String value) {
        boolean status=true;
        if(value == null || value.length() <=0) {
            return false;
        }
        StringTokenizer token = new StringTokenizer(value," ");
        while(token.hasMoreElements()) {
            String item = token.nextToken();
            status = super.verifyValue(item);
            if(!status)
                return status;
        }
        return status;
    }   

}




