/*
 * Created on Nov 18, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.eso.ohs.persistence.dbase.phase2;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.EphemerisFile;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.ObjectNotFoundException;

/**
 * Class EphFilesDBIO
 * 
 * TODO Javadoc
 * 
 * @version $Revision: 1.1 $
 * @author tcanavan, Nov 18, 2004
 */

// $Id: EphFilesDBIO.java,v 1.1 2005/03/30 09:56:12 tcanavan Exp $
public class EphFilesDBIO {

    /** Standard log channel */
    private static Logger stdlog_ = Logger.getLogger(EphFilesDBIO.class);

    private static String obrepDbName = Config.getCfg().getDbName(
            ObservationBlock.getSuffix());

    private static String opcDB_ = Config.getCfg().getDbName(
            ObservingRun.getSuffix());

    /**
     * Read eph file from the database.
     * 
     * @param conn
     * @param boId
     * @throws ObjectIOException
     * @throws SQLException
     * @throws IOException
     * @throws ObjectNotFoundException
     */

    public static EphemerisFile read(Connection conn, long obId)
            throws ObjectIOException, SQLException, IOException,
            ObjectNotFoundException {

        EphemerisFile ephFile = new EphemerisFile();
        String maxSize = "SELECT max(datalength(file_data)) from "
                + obrepDbName + "..ephemeris_file";
        Statement stmt = conn.createStatement();
        ResultSet rs = stmt.executeQuery(maxSize);
        int textLenMax = 0;
        while (rs.next()) {
            textLenMax = rs.getInt(1);
        }
        rs.close();
        stmt.execute("set TEXTSIZE " + textLenMax);
        String sqlText = "SELECT " + obrepDbName
                + "..ephemeris_file.file_data, " 
                + obrepDbName + "..ephemeris_file.file_name " 
                +  " from " + obrepDbName
                + "..ephemeris_file where " + obrepDbName
                + "..ephemeris_file.ob_id = ?";
        stdlog_.debug(sqlText);
        PreparedStatement pstmt = conn.prepareStatement(sqlText);
        pstmt.setLong(1, obId);
        rs = pstmt.executeQuery();
        boolean found = false;
        while (rs.next()) {
            ephFile.setFileString(rs.getString(1));
            ephFile.setFilename(rs.getString(2));
        }
        rs.close();
        pstmt.close();
        return ephFile;
    }
    
    /**
     * wrute eph file from the database.
     * 
     * @param conn
     * @param boId
     * @param ephFile to the database
     * @throws ObjectIOException
     * @throws SQLException
     * @throws IOException
     * @throws ObjectNotFoundException
     */

    public static void write(Connection conn, long obId,EphemerisFile ephFile)
            throws  SQLException  {

        String sql = "INSERT INTO " + obrepDbName + "..ephemeris_file (ob_id,file_name,file_data) "
                     + " VALUES (?,?,?)";
        stdlog_.debug(sql);             
        PreparedStatement stmt = conn.prepareStatement(sql);             
        stmt.setLong(1,obId);
        stmt.setString(2,ephFile.getFilename());
        stmt.setString(3,ephFile.getFileString());        
        stmt.execute();
        stmt.close();
    }
    
    /**
     * Read time intervals
     * @param stmt Sql statement
     * @param boId Delete time intervals that have this id
     * @exception SQLException
     *          an error occurred during the dbase operation
     */


    public static void delete(Statement stmt, long id)
                    throws SQLException {
    String sqlText = "DELETE FROM ephemeris_file "
        + " WHERE ob_id = " + id;

    stdlog_.debug(sqlText);
    stmt.executeUpdate(sqlText);    
    }


    
    

}