package org.eso.ohs.phase2.actions;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JSpinner;
import javax.swing.JTextField;

import org.eso.ohs.phase2.visiplot.ChartColorItem;
/**
 * This action provide a simple blend alghoritm
 * @author gdonino
 *
 */
public class AutoColorAction implements ActionListener {
	
	private ArrayList items;
	private Color defaultLabelColor = new Color(10, 10, 80);
	private final int MAX_COLOR_VALUE = 255; // max value for any color
	private JSpinner blendText;
	public AutoColorAction(ArrayList items, JSpinner blend){
		this.items = items;
		this.blendText = blend;
	}

	public void actionPerformed(ActionEvent arg0) {
		
		for (int i = 0; i < items.size(); i++){
			ChartColorItem item = (ChartColorItem) items.get(i);
			Color source = item.getAreaColor();
			int red = blendComponent(source.getRed());
			int green = blendComponent(source.getGreen());
			int blue = blendComponent(source.getBlue());
			
			item.setPerimeterColor(new Color(red, green, blue));
			item.setLabelsColor(defaultLabelColor);
		}		
	}
	
	private int blendComponent(int colComponent){
		int blend = ((Integer)blendText.getValue()).intValue();
		int result = ((blend*(MAX_COLOR_VALUE - colComponent)) >> 8) + colComponent;
		return result;
	}

}
