package org.eso.ohs.phase2.apps.ot.wizard;

import java.util.Date;

import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.dfs.Seeing;
import org.eso.ohs.dfs.SkyTransparency;
import org.eso.ohs.dfs.StrehlRatio;
import org.eso.ohs.dfs.WeatherConstraint;
import org.eso.ohs.phase2.visibility.VisicalcOptions;

public class OrangModelDefault implements OrangModel {
   private int obSelectionType;
    private String obSelectionTelescope = "";
    private String obSelectionQueue = "";
    private String [] selectedQueues = new String[0];
     
    private Seeing  seeingValue = new Seeing("0.2");
    private SkyTransparency  skyTransp;
    private StrehlRatio  strehlRatio;
    
    private boolean fliConstrain = false; 
    private boolean moonDistanceConstrain = false; 
    private boolean sunAngleConstrain = false;
    private boolean moonAngleConstrain = false;
   
    private int fliRelaxPercentage = 0; 
    private int moonRelaxPercentage = 0;   
    private int airmassValuePercentage = 0;   
    private int sunAngleDegree = -18;
    private int moonAngleDegree = -18;
   
    private String rankingAlgorithm ;
    private boolean timeConstrain;
    private boolean sidTimeConstrain;
    private String user;
    private Date startDate;
    private Date endDate;
    private int interval;
    private double latitude_;
    private double longitude_; 
    private String timelineAlgorithm = null;
    private WeatherConstraint weatherConstraint;
    private String[] currentQueueTel;
    private String[] currentQueueInst;
    private boolean zenithConstrain; 
    
    
    public OrangModelDefault() {
        super();
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getObSelectionQueue()
     */
    public String getObSelectionQueue() {
        return obSelectionQueue;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setObSelectionQueue(java.lang.String)
     */
    public void setObSelectionQueue(String obSelectionQueue) {
        this.obSelectionQueue = obSelectionQueue;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getObSelectionTelescope()
     */
    public String getObSelectionTelescope() {
        return obSelectionTelescope;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setObSelectionTelescope(java.lang.String)
     */
    public void setObSelectionTelescope(String obSelectionTelescope) {
        this.obSelectionTelescope = obSelectionTelescope;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getObSelectionType()
     */
    public int getObSelectionType() {
        return obSelectionType;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setObSelectionType(int)
     */
    public void setObSelectionType(int obSelectionType) {
        this.obSelectionType = obSelectionType;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getSeeingValue()
     */
    public Seeing getSeeingValue() {
        return seeingValue;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setSeeingValue(org.eso.ohs.dfs.Seeing)
     */
    public void setSeeingValue(Seeing seeingValue) {
        this.seeingValue = seeingValue;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getSkyTransp()
     */
    public SkyTransparency getSkyTransp() {
        return skyTransp;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setSkyTransp(org.eso.ohs.dfs.SkyTransparency)
     */
    public void setSkyTransp(SkyTransparency skyTransp) {
        this.skyTransp = skyTransp;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getStrehlRatio()
     */
    public StrehlRatio getStrehlRatio() {
        return strehlRatio;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setStrehlRatio(org.eso.ohs.dfs.StrehlRatio)
     */
    public void setStrehlRatio(StrehlRatio strehlRatio) {
        this.strehlRatio = strehlRatio;
    }



    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getAirmassValuePercentage()
     */
    public int getAirmassValuePercentage() {
        return airmassValuePercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setAirmassValuePercentage(int)
     */
    public void setAirmassValuePercentage(int airmassValuePercentage) {
        this.airmassValuePercentage = airmassValuePercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#isFliConstrain()
     */
    public boolean isFliConstrain() {
        return fliConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setFliConstrain(boolean)
     */
    public void setFliConstrain(boolean fliConstrain) {
        this.fliConstrain = fliConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getFliRelaxPercentage()
     */
    public int getFliRelaxPercentage() {
        return fliRelaxPercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setFliRelaxPercentage(int)
     */
    public void setFliRelaxPercentage(int fliRelaxPercentage) {
        this.fliRelaxPercentage = fliRelaxPercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#isMoonAngleConstrain()
     */
    public boolean isMoonAngleConstrain() {
        return moonAngleConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setMoonAngleConstrain(boolean)
     */
    public void setMoonAngleConstrain(boolean moonAngleConstrain) {
        this.moonAngleConstrain = moonAngleConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getMoonAngleDegree()
     */
    public int getMoonAngleDegree() {
        return moonAngleDegree;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setMoonAngleDegree(int)
     */
    public void setMoonAngleDegree(int moonAngleDegree) {
        this.moonAngleDegree = moonAngleDegree;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#isMoonDistanceConstrain()
     */
    public boolean isMoonDistanceConstrain() {
        return moonDistanceConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setMoonDistanceConstrain(boolean)
     */
    public void setMoonDistanceConstrain(boolean moonDistanceConstrain) {
        this.moonDistanceConstrain = moonDistanceConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getMoonRelaxPercentage()
     */
    public int getMoonRelaxPercentage() {
        return moonRelaxPercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setMoonRelaxPercentage(int)
     */
    public void setMoonRelaxPercentage(int moonRelaxPercentage) {
        this.moonRelaxPercentage = moonRelaxPercentage;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#isSunAngleConstrain()
     */
    public boolean isSunAngleConstrain() {
        return sunAngleConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setSunAngleConstrain(boolean)
     */
    public void setSunAngleConstrain(boolean sunAngleConstrain) {
        this.sunAngleConstrain = sunAngleConstrain;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getSunAngleDegree()
     */
    public int getSunAngleDegree() {
        return sunAngleDegree;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setSunAngleDegree(int)
     */
    public void setSunAngleDegree(int sunAngleDegree) {
        this.sunAngleDegree = sunAngleDegree;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#setRankingAlgorithm(java.lang.String)
     */
    public void setRankingAlgorithm(String rankingAlgorithm) {
        this.rankingAlgorithm = rankingAlgorithm;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getRankingAlgorithm()
     */
    public String getRankingAlgorithm() {
        return rankingAlgorithm;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModelInterface#getVisiCalcOptions()
     */
    public VisicalcOptions getVisiCalcOptions() {
    	VisicalcOptions options = new VisicalcOptions();
        
        options.setCalcFli(isFliConstrain()); 
        options.setCalcMoonDist(isMoonDistanceConstrain()); 
        options.setCalcSun(isSunAngleConstrain());
        options.setCalcMoon(isMoonAngleConstrain());
        options.setCalcTimeInterval(isTimeIntervalConstrain());
        options.setCalcSiderealTimeInterval(isSidTimeIntervalConstrain());
        
        options.setFliTolerance(getFliRelaxPercentage()); 
        options.setMoonConstraint(getMoonRelaxPercentage());   
        options.setAirmassTolerance(getAirmassValuePercentage());   
        options.setSunConstraint(getSunAngleDegree());
        options.setMoonConstraint(getMoonAngleDegree());
        
         return options;
    }


    public boolean isTimeIntervalConstrain() {
        return timeConstrain;
    }


    public boolean isSidTimeIntervalConstrain() {
        return sidTimeConstrain;
    }
    
    public void setTimeIntervalConstrain(boolean value) {
        this.timeConstrain = value;
    }


    public void setSidTimeIntervalConstrain(boolean value) {
        this.sidTimeConstrain = value;
    }


    public String getUser() {
     
        return user;
    }


    public boolean isSuperUser() {
        return false;
    }


    /**
     * @param user The user to set.
     */
    public void setUser(String user) {
        this.user = user;
    }


    public Date getStartDate() {     
        return startDate;
    }


    public Date getEndDate() {
        return endDate;
    }


    public int getStepInterval() {
        return interval;
    }


    public void setStartDate(Date date) {     
       startDate = date;
    }


    public void getEndDate(Date date) {
         endDate = date;
    }


    public void getStepInterval(int step) {
         interval = step;
    }


    public double getLatitude() {
     
        return latitude_;
    }


    public double getLongitude() {
        return longitude_;
    }

    public void setLatitude(double latitude) {
       latitude_ = latitude;
    }


    public void setLongitude(double longitude) {
        longitude_ = longitude;
    }


    public String getEndISODate() {
     
        return Convert.dateToIsoDate(getEndDate());
    }


    public String getStartISODate() {
       return Convert.dateToIsoDate(getStartDate());
    }


	public String[] getSelectedQueues() {
		return(selectedQueues);
	}


	public void setSelectedQueues(String[] selectedQueues) {
		this.selectedQueues = selectedQueues;
	}


    // amchavan & pnunes, 17-Oct-2005: added
    public String getTimelineAlgorithm() {
        return timelineAlgorithm;
    }

    // amchavan & pnunes, 17-Oct-2005: added
    public void setTimelineAlgorithm( String timelineAlgorithm ) {
        this.timelineAlgorithm = timelineAlgorithm;
    }


    /**
     * @param weatherConstraint The weatherConstraint to set.
     */
    public void setWeatherConstraint(WeatherConstraint weatherConstraint) {
        this.weatherConstraint = weatherConstraint;
    }


    /**
     * @param currentQueueTel void
     */
    public void setQueuesTelescopes(String[] currentQueueTel) {
        this.currentQueueTel = currentQueueTel;
    }


    /**
     * @param currentQueueInst void
     */
    public void setQueuesInstruments(String[]  currentQueueInst) {
        this.currentQueueInst = currentQueueInst;
    }


    /**
     * @return Returns the weatherConstraint.
     */
    public WeatherConstraint getWeatherConstraint() {
        return weatherConstraint;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModel#getQueuesTelescopes()
     */
    public String[] getQueuesTelescopes() {
        return currentQueueTel;
    }


    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModel#getQueuesInstruments()
     */
    public String[] getQueuesInstruments() {
         return currentQueueInst;
    }


    /**
     * 
     * @param verifyZenith defines if the zenith constraint must be verified.
     * 
     */
    public void setTelescopeZenithConstraint(boolean verifyZenith) {     
        this.zenithConstrain = verifyZenith;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.phase2.apps.ot.wizard.OrangModel#isTelescopeZenithConstraint()
     */
    public boolean isTelescopeZenithConstraint() {
      
        return zenithConstrain;
    }
 

}
