package org.eso.ohs.phase2.icdVcs;

import java.sql.SQLException;

import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.OHSApplication;
import org.eso.ohs.persistence.dbase.phase2.DbaseHandlerCB;
import org.eso.ohs.persistence.dbase.phase2.OBHistory;
import org.eso.ohs.persistence.dbase.phase2.TemplateSigDBIO;

/**
 * Added class to provess template status events This class must 
 * run the AWT Thread and called with SwingUtils.invokeAndWait();
 * @author tcanavan
 *
 * 
 */
public class ProcessTemplateStatusEvents implements Runnable {

    private int obId;

    private String BOBEventType;

    private String templateName;

    private int tsNo;

    public ProcessTemplateStatusEvents(
        String BOBEventType,
        int obId,
        int tsNo) {
        this.obId = obId;
        this.BOBEventType = BOBEventType;
        this.tsNo = tsNo;
    }

    /**
     * @see java.lang.Runnable#run()
     */
    public void run() {
        String status = CalibrationBlock.convertBobEventToStatus(BOBEventType);
        // Put in call to update logs
        try {
            String obType = DbaseHandlerCB.getObTypeFromDatabaseId(obId);
            String templateName = null;
            if (obType.equals("O")) {
                templateName = TemplateSigDBIO.getTemplateName(obId, tsNo);
            } else {
                templateName = TemplateSigDBIO.getTemplateName(obId, tsNo + 1);
            }
            OBHistory.addEvent(
                obId,
                templateName,
                OHSApplication.getShortDesc(),
                new Integer(Config.getCfg().getUserName()).toString(),
                status);
        } catch (SQLException e) {
            ErrorMessages.announceIOError(null, e);
        }
    }

}
